


\newcommand{\var}{t}
 

A Lucky program is an interpreted automaton whose transitions define
the reactions of the machine.  Each transition is labelled by 
\begin{enumerate}
\item a set of constraints (a relation) that defines the set of the
possible outputs for one step, and
\item a weight that defines the relative probability for its
transition to be taken.
\end{enumerate}


We explain the operational semantics of Lucky on the 
automaton of Figure~\ref{fig:lucky_example}, which has one
Boolean input $switch$, and one real output $\var$. 




% \begin{figure}[h]
%   \begin{center}
%       \scalebox{.5}{\input{lucky-ex}}
%   \end{center}
% \begin{tabbing}
% ====\=====\====\= ===, \=  \kill  \\
% where:    
% \> $up\_and\_down(X, Min, Max, Bound) \ =  
% % $\\ \> \> $ 
% |X - pre \ X| < Bound \ \ \wedge $\\
% \> \> $  (${\bf if} \> $  (pre \ X < Min) \ \  \vee \  \ ((pre  \  X < Max) \wedge (pre \ pre \ X \leq pre \ X)) $\\
% \> \> \>     {\bf then}  \> $ (X > pre  \  X)  \ \ ${\bf else}$ \  \ (X < pre \ X) ) $
% \end{tabbing}
%   \caption{A Lucky automaton with one Boolean input $switch$ and one real output~$\var$.}
%   \label{fig:lucky_example}
% \end{figure}




\paragraph{\bf The relation level.}

Each transition in this automaton is labelled by a relation (a
conjunction of constraints) and a weight (an integer).  Each
relation, which holds over the automaton input, output, and memories
(e.g., $pre \ \var$), defines how to compute one step of this
synchronous machine.

\begin{itemize}

\item The relation ``$switch \wedge \var = pre \ \var$'' is satisfiable if
and only if the input $switch$ is true; it states that $\var$
keeps its previous value.


\item The relation ``$up\_and\_down(\var,0,10,1)$'' constraints the
output $\var$ in the following manner: the difference between
$\var$ and its previous value is never smaller than $1$ ($|\var -
pre \ \var| < 1$); if $\var$ was increasing (resp. decreasing) at
the previous step ($pre \ pre \ \var \leq pre \ \var$) then
$\var$ will increase (resp. decrease) at the current step, unless
its previous value is bigger than $10$ (resp.  smaller than $0$). 
%
See Figure~\ref{t2a-rif}  in order to see the shape of
a timing diagram of a variable constrained by such a kind of
relation.  We will use that macro in most the examples of the
article.

\item The relation ``$up\_and\_down(\var,0,10,4)$'' is similar,
except that the bound over the derivative of $\var$ is set to $4$
instead of $1$.
\end{itemize}

 


\paragraph{\bf The control level.}


Suppose now that the current node is $\mathit{1}$ (the behavior of
this automaton is symmetric if the current node is {$2$}).
%
If the input $switch$ is false, then only one transition is possible:
the one labelled by $up\_and\_down(\var,0,10,1)$. This constraint
will therefore be solved, and one solution will be drawn among its
set of solutions.
%
%
If the input $switch$ is true, then the transition from 1 to 2 is 
also possible.
%
One is labelled by a weight of 1, and the other by a weight of
$1000$; the latter will be drawn with a probability of $1000/1001$.


Such an automaton models the fact that the control can move from one
mode to another only when the input $switch$ is true. It also models
that the current mode might not change even if $switch$ is true
(with a probability of 0.1 \%), which can be convenient to model
occasional errors for instance.


Note that there is two sources of non-determinism in Lucky: one at
the relation level, where several solutions to a set of constraints
exist; and one at the control level, over which we have some
quantitative control via the use of weights.
%
%



\paragraph{\bf Dynamic weights and transient nodes.}
% \paragraph{\bf Other Lucky concepts.}
Two other important concepts of Lucky are not described on this
example, but they will be illustrated later:
% the remaining of the article:

\begin{enumerate}
\item the concept of \emph{dynamic weights}; weight labels can also be
numerical functions of the inputs and the past-values.
%
This can be particularly useful to model an {\em alive process} where
the system has a known average life expectancy before breaking down;
at each reaction, the probability to work properly depends {\em
numerically} on an internal counter of the process age.


%  (input or memory) integer variables, which is convenient to describe
%  processes that wear out;
\item and the concept of \emph{transient} and \emph{stable nodes},
which is simply a facility that help to structure Lucky programs
better.  A complete reaction is a sequence of transitions between two
stable nodes, where all the intermediate nodes are transient. The
constraints that are used to perform one reaction is the conjunction
of the constraints labelling the transitions between the two stable
nodes.
\end{enumerate}




\paragraph{\bf Restrictions.}
One restriction on the current version of Lucky is that the
constraints on inputs, at a given point of a sequence, may only
depend on the {\em past} values of outputs (as in Lustre). Another
restriction is that numeric constraints on outputs should be
linear. 
%
% For instance, $x+y > 3$ can be handled, but not
% $x_1^2+x_2^2>2$ nor $log~x_1 + sin~x_2 > e^{x_3}$.
%
Please refer to the \emph{Lucky language reference manual}~\cite{lucky-man}
for more information. 
